package com.tidecloud.dataacceptance.entity;

import java.io.Serializable;

/**
 * @author: chudk
 * @date: 2017年10月12日 下午8:01:04
 */
public class ConnectMsg implements Serializable {

    private static final long serialVersionUID = -2930377109437562910L;
    private String ip;
    private String socketId;

    public ConnectMsg() {
    }

    public ConnectMsg(String ip, String socketId) {
        super();
        this.ip = ipToLong(ip);
        this.socketId = socketId;
    }

    public String getIp() {
        return ip;
    }

    public void setIp(String ip) {
        this.ip = ip;
    }

    public String getSocketId() {
        return socketId;
    }

    public void setSocketId(String socketId) {
        this.socketId = socketId;
    }

    /**
     * 把IP地址转化为int
     * 
     * @param ipAddr
     * @return int
     */
    public static String ipToLong(String ipAddress) {
        long result = 0;
        String[] ipAddressInArray = ipAddress.split("\\.");
        for (int i = 3; i >= 0; i--) {
            long ip = Long.parseLong(ipAddressInArray[3 - i]);
            // left shifting 24,16,8,0 and bitwise OR
            // 1. 192 << 24
            // 1. 168 << 16
            // 1. 1 << 8
            // 1. 2 << 0
            result |= ip << (i * 8);
        }
        return String.valueOf(result);
    }

    public static void main(String[] args) {
        ConnectMsg connectMsg = new ConnectMsg("192.168.0.1", "a");
        System.out.println(connectMsg.getIp());
    }

}
