package com.tidecloud.dataacceptance.entity;

import java.io.Serializable;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import com.tidecloud.dataacceptance.common.DateUtil;

/**   
 * @author: chudk 
 * @date:   2017年9月18日 上午11:04:09   
 */
public class Device implements Serializable{

    private static final long serialVersionUID = 684382625782853174L;
    
    private Date timestamp;
    private Double lng;
    private Double lat;
    private Double speed;
    private Double electric;
    private Integer step;
    private Integer terminalState;
    private String deviceId;
    private String itemState;
    
    public String getItemState() {
        return itemState;
    }
    public void setItemState(String itemState) {
        this.itemState = itemState;
    }
    public String getDeviceId() {
        return deviceId;
    }
    public void setDeviceId(String deviceId) {
        this.deviceId = deviceId;
    }
    public Date getTimestamp() {
        return timestamp;
    }
    public void setTimestamp(Date timestamp) {
        this.timestamp = timestamp;
    }
    public Double getLng() {
        return lng;
    }
    public void setLng(Double lng) {
        this.lng = lng;
    }
    public Double getLat() {
        return lat;
    }
    public void setLat(Double lat) {
        this.lat = lat;
    }
    public Double getSpeed() {
        return speed;
    }
    public void setSpeed(Double speed) {
        this.speed = speed;
    }
    public Double getElectric() {
        return electric;
    }
    public void setElectric(Double electric) {
        this.electric = electric;
    }
    public Integer getStep() {
        return step;
    }
    public void setStep(Integer step) {
        this.step = step;
    }
    public Integer getTerminalState() {
        return terminalState;
    }
    public void setTerminalState(Integer terminalState) {
        this.terminalState = terminalState;
    }
    @Override
    public String toString() {
        return "Device [timestamp=" + timestamp + ", lng=" + lng + ", lat=" + lat + ", speed=" + speed + ", electric="
                + electric + ", step=" + step + ", terminalState=" + terminalState + ", deviceId=" + deviceId + "]";
    }
    public static String buildDeviceStr(Device device){
        Date timestamp = device.getTimestamp();
        timestamp = DateUtil.calculateByHour(timestamp, 8);
        String date = new SimpleDateFormat("yyMMddHHmmss").format(timestamp);
        StringBuilder builder = new StringBuilder();
        builder.append(device.getDeviceId()).append(",");
        builder.append(date).append(",");
        builder.append(device.getItemState()).append(",");
        builder.append(device.getLng()).append(",");
        builder.append(device.getLat()).append(",");
        builder.append(device.getSpeed()).append(",");
        builder.append(device.getStep()).append(",");
        builder.append(device.getElectric());
        
        return builder.toString();
    }
    
    public static void main(String[] args) {
        Date parse;
        try {   
            parse = new SimpleDateFormat("yyMMddHHmmss").parse("170228235504");
            Date calculateByDate = DateUtil.calculateByHour(parse, 8);
            String format = new SimpleDateFormat("yy-MM-dd HH:mm:ss").format(calculateByDate);
            System.out.println(format);
        } catch (ParseException e) {
            e.printStackTrace();
        }
    }
}
