package com.tidecloud.dataacceptance.entity;

import java.net.SocketAddress;

import io.netty.channel.Channel;

/**   
 * @author: chudk 
 * @date:   2017年11月8日 上午11:32:28   
 */
public class Session {
    private String id;
    private String deviceId;
    private Channel channel = null;
    private boolean isAuthenticated = false;
    //message serial number
    private int currentFlowId = 0;
    //client last link time, such value change have 2 situation
    //1. terminal -- > server heart beat package
    //2. terminal -- > server data package
    private long lastCommunicateTimeStamp = 0L;
    
    public Session() {
    }
    public String getId() {
        return id;
    }
    public void setId(String id) {
        this.id = id;
    }
    public String getDeviceId() {
        return deviceId;
    }
    public void setDeviceId(String deviceId) {
        this.deviceId = deviceId;
    }
    public Channel getChannel() {
        return channel;
    }
    public void setChannel(Channel channel) {
        this.channel = channel;
    }
    public boolean isAuthenticated() {
        return isAuthenticated;
    }
    public void setAuthenticated(boolean isAuthenticated) {
        this.isAuthenticated = isAuthenticated;
    }
    public int getCurrentFlowId() {
        return currentFlowId;
    }
    public void setCurrentFlowId(int currentFlowId) {
        this.currentFlowId = currentFlowId;
    }
    public long getLastCommunicateTimeStamp() {
        return lastCommunicateTimeStamp;
    }
    public void setLastCommunicateTimeStamp(long lastCommunicateTimeStamp) {
        this.lastCommunicateTimeStamp = lastCommunicateTimeStamp;
    }
    public static String buildId(Channel channel) {
        return channel.id().asLongText();
    }

    public static Session buildSession(Channel channel) {
        return buildSession(channel, null);
    }

    public static Session buildSession(Channel channel, String deviceId) {
        Session session = new Session();
        session.setChannel(channel);
        session.setId(buildId(channel));
        session.setDeviceId(deviceId);
        session.setLastCommunicateTimeStamp(System.currentTimeMillis());
        return session;
    }

    public SocketAddress getRemoteAddr() {
        System.out.println(this.channel.remoteAddress().getClass());

        return this.channel.remoteAddress();
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((id == null) ? 0 : id.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj){
            return true;
        }
        if (obj == null){
            return false;
        }
        if (getClass() != obj.getClass()){
            return false;
        }
        Session other = (Session) obj;
        if (id == null) {
            if (other.id != null){
                return false;
            }
        } else if (!id.equals(other.id)){
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "Session [id=" + id + ", terminalPhone=" + deviceId + ", channel=" + channel + "]";
    }

    public synchronized int currentFlowId() {
        if (currentFlowId >= 0xffff){
            currentFlowId = 0;
        }
        return currentFlowId++;
    }
    
}
