package com.tidecloud.dataacceptance.entity;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import com.tidecloud.dataacceptance.common.DateUtil;

/**   
 * @author: chudk 
 * @date:   2018年1月23日 下午2:12:24   
 */
public class YiTongGpsForWarnDevice extends YiTongGPSDevice {

    private static final long serialVersionUID = -9157286369663317479L;
    
    /**@see: 电压等级，0x00:无电  0x01:电量极低(不足以打电话发短信) 0x02:电量很低(低电报警) 0x03:电量底(可正常使用)
     * 0x04:电量中  0x05:电量高  0x06:电量极高
     * */
    private Integer electric;
    
    /** @see: GSM信号等级， 0x00:无信号  0x01:信号极弱  0x02:信号较弱  0x03:信号良好  0x04:信号强*/
    private Integer gmsSign;
    
    /** @see: 报警原因， 0x00:正常报警  0x01:SOS求救  0x03:震动报警  等 */
    private Integer warningReason;

    /** @see: 终端信息详解*/
    private Integer terminalMsg;
    
    public Integer getTerminalMsg() {
        return terminalMsg;
    }
    public void setTerminalMsg(Integer terminalMsg) {
        this.terminalMsg = terminalMsg;
    }
    public Integer getElectric() {
        return electric;
    }
    public void setElectric(Integer electric) {
        this.electric = electric;
    }
    public Integer getGmsSign() {
        return gmsSign;
    }
    public void setGmsSign(Integer gmsSign) {
        this.gmsSign = gmsSign;
    }
    public Integer getWarningReason() {
        return warningReason;
    }
    public void setWarningReason(Integer warningReason) {
        this.warningReason = warningReason;
    }
    
    public String buildDeviceStr(){
        // [设备号] [日期] [gpsCount] [经度] [维度] [速度] [电压等级] [GSM信号等级] [报警原因] [终端信息详解] [] [] [数据类型]
        SimpleDateFormat sdf = new SimpleDateFormat("yyMMddHHmmss");
        Date date = new Date();
        try {
            date = sdf.parse(this.getDate());
        } catch (ParseException e) {
            e.printStackTrace();
        }
        date = DateUtil.calculateByHour(date, 8);
        String dateStr = sdf.format(date);
        StringBuilder builder = new StringBuilder();
        builder.append(checkoutNullObject(this.getDeviceId())).append(",");
        builder.append(checkoutNullObject(dateStr)).append(",");
        builder.append(checkoutNullObject(this.getGpsCount())).append(",");
        builder.append(checkoutNullObject(this.getLng())).append(",");
        builder.append(checkoutNullObject(this.getLat())).append(",");
        builder.append(checkoutNullObject(this.getSpeedbyte())).append(",");
        builder.append(checkoutNullObject(this.getElectric())).append(",");
        builder.append(checkoutNullObject(this.getGmsSign())).append(",");
        builder.append(checkoutNullObject(this.getWarningReason())).append(",");
        builder.append(checkoutNullObject(this.getTerminalMsg())).append(',').append(',').append(',').append(3);
        return builder.toString();
    }
    
    private static String checkoutNullObject(Object t){
        if (t == null) {
            return "";
        }
        return String.valueOf(t);
    }
}
