package com.tidecloud.dataacceptance.entity;

import java.io.Serializable;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import com.tidecloud.dataacceptance.common.DateUtil;

/**   
 * @author: chudk 
 * @date:   2017年9月18日 上午11:04:09   
 */
public class YuGuangGPSDevice implements Serializable{

    private static final long serialVersionUID = 684382625782853174L;
    
    private String deviceId;
    private String date;
    private String lat;
    private String lng;
    private String speed;
    private String mileage;
    
    private Integer oil;
    
   
    public Integer getOil() {
        return oil;
    }
    public void setOil(Integer oil) {
        this.oil = oil;
    }
    public YuGuangGPSDevice() {
    }
    public String getDeviceId() {
        return deviceId;
    }

    public void setDeviceId(String deviceId) {
        this.deviceId = deviceId;
    }

    public String getDate() {
        return date;
    }

    public void setDate(String date) {
        this.date = date;
    }

    public String getSpeed() {
        return speed;
    }

    public void setSpeed(String speed) {
        this.speed = speed;
    }

    public String getLat() {
        return lat;
    }
    public void setLat(String lat) {
        this.lat = lat;
    }
    public String getLng() {
        return lng;
    }
    public void setLng(String lng) {
        this.lng = lng;
    }
    public String getMileage() {
        return mileage;
    }
    public void setMileage(String mileage) {
        this.mileage = mileage;
    }
    public static String buildDeviceStr(YuGuangGPSDevice device){
        // [设备号] [日期] [gpsCount] [经度] [维度] [速度] [里程] [是否补传] [数据上报模式] [移动基站] [LAC] [MCC] [信息类型 1代表location， 0代表电压] [电压]
        SimpleDateFormat sdf = new SimpleDateFormat("yyMMddHHmmss");
        Date date = new Date();
        try {
            date = sdf.parse(device.getDate());
        } catch (ParseException e) {
            e.printStackTrace();
        }
        date = DateUtil.calculateByHour(date, 8);
        String dateStr = sdf.format(date);
        StringBuilder builder = new StringBuilder();
        builder.append(checkoutNullObject(device.getDeviceId())).append(",");
        builder.append(checkoutNullObject(dateStr)).append(",");
        builder.append(checkoutNullObject(device.getLng())).append(",");
        builder.append(checkoutNullObject(device.getLat())).append(",");
        builder.append(checkoutNullObject(device.getSpeed())).append(",");
        builder.append(checkoutNullObject(device.getMileage())).append(",");
        builder.append(checkoutNullObject(device.getOil()));
        return builder.toString();
    }
    
    private static String checkoutNullObject(Object t){
        if (t == null) {
            return "";
        }
        return String.valueOf(t);
    }
}
